VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "15"
   ClientHeight    =   3990
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3990
   ScaleWidth      =   4560
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

DefLng A-Z
Dim emptyID, curID, i
Const size = 1000, gap = 48
Dim cells(1 To 16)

Private Sub Form_Load()
  AutoRedraw = True: Font.size = 18: BackColor = vbBlue: ForeColor = vbCyan
  Width = size * 4 + gap * 3: Height = size * 4 + gap * 3 + 300
  For i = 1 To 16: cells(i) = i: Next
  emptyID = 16: Randomize: Shuffle 200
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim id: id = Int(Y / size) * 4 + Int(X / size) + 1
  i = Abs(id - emptyID): If (i <> 4) And (i <> 1) Then Exit Sub
  curID = id: Swap
  PrintCell emptyID: PrintCell curID
  If Win Then MsgBox "Win!", , "15": Shuffle 200
End Sub

Private Sub Shuffle(n)
  Dim X, Y, md, c As Collection
  For i = 1 To n
    Set c = New Collection
    XY emptyID - 1, X, Y, 1
    If (X > 0) And (md <> 1) Then c.Add -1
    If (X < 3) And (md <> -1) Then c.Add 1
    If (Y > 0) And (md <> 4) Then c.Add -4
    If (Y < 3) And (md <> -4) Then c.Add 4
    md = c(Int(Rnd * c.Count) + 1)
    curID = emptyID + md
    Swap
  Next
  For i = 1 To 16: PrintCell i: Next
End Sub

Private Sub PrintCell(n)
  Dim X, Y, s As String
  XY n - 1, X, Y, size
  Line (X + gap, Y + gap)-(X + size - gap, Y + size - gap), &HA0A0A0, BF
  s = cells(n): If s = 16 Then Exit Sub
  CurrentX = X + (size - TextWidth(s)) / 2: CurrentY = Y + (size - TextHeight(s)) / 2
  Print s
End Sub

Private Sub Swap()
  Dim id: id = emptyID
  cells(id) = cells(curID): cells(curID) = 16
  emptyID = curID: curID = id
End Sub

Private Function Win() As Boolean
  For i = 1 To 16
    If cells(i) <> i Then Exit Function
  Next
  Win = True
End Function

Private Sub XY(n, X, Y, k)
  X = (n And 3) * k: Y = (n \ 4) * k
End Sub
